## 4번 단어 뒤집기

4. 단어 뒤집기
설명

N개의 단어가 주어지면 각 단어를 뒤집어 출력하는 프로그램을 작성하세요.


입력
첫 줄에 자연수 N(3<=N<=20)이 주어집니다.

두 번째 줄부터 N개의 단어가 각 줄에 하나씩 주어집니다. 단어는 영어 알파벳으로만 구성되어 있습니다.


출력
N개의 단어를 입력된 순서대로 한 줄에 하나씩 뒤집어서 출력합니다.


예시 입력 1 

3
good
Time
Big

예시 출력 1

doog
emiT
giB

출처 : https://cote.inflearn.com/contest/10/problem/01-04

## 내가 푼 코드

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class 단어_뒤집기 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int t = Integer.parseInt(br.readLine());
        while(t-- > 0) {
            String[] input = br.readLine().split("");
            for (int i = 0; i < input.length; i++) {
                System.out.print(input[(input.length - 1) - i]);
            }
            System.out.println();
        }
        br.close();
    }
}
```

## StringBuilder가 제공하는 reverse() 사용

StringBuilder는 String과 다르게 입력받은 문자열에 추가하거나 변형해도 새로운 문자열 객체를 생성하지 않는다.

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class 단어_뒤집기 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int t = Integer.parseInt(br.readLine());
        while (t-- > 0) {
            String input = br.readLine();
            String reverse = new StringBuilder(input).reverse().toString();
            System.out.println(reverse);
//            String[] input = br.readLine().split("");
//            for (int i = 0; i < input.length; i++) {
//                System.out.print(input[(input.length - 1) - i]);
//            }
//            System.out.println();
        }
        br.close();
    }
}
```

## while문과 lt, rt를 줄여가며 바꾸는 방식

char[]를 String으로 바꾸는 것에 주의(그냥 toString으로 바꾼 경우 주소값만 나옴)

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class 단어_뒤집기 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int t = Integer.parseInt(br.readLine());
        while (t-- > 0) {
            String input = br.readLine();
            char[] s = input.toCharArray();
            int lt=0, rt=input.length()-1;
            while(lt<rt){
                char temp = s[lt];
                s[lt] = s[rt];
                s[rt] = temp;
                lt++;
                rt--;
            }
            String answer = String.valueOf(s);
            System.out.println(answer);
        }
        br.close();
    }
}
```