## 7번 회문 문자열

7. 회문 문자열
설명

앞에서 읽을 때나 뒤에서 읽을 때나 같은 문자열을 회문 문자열이라고 합니다.

문자열이 입력되면 해당 문자열이 회문 문자열이면 "YES", 회문 문자열이 아니면 “NO"를 출력하는 프로그램을 작성하세요.

단 회문을 검사할 때 대소문자를 구분하지 않습니다.


입력
첫 줄에 길이 100을 넘지 않는 공백이 없는 문자열이 주어집니다.


출력
첫 번째 줄에 회문 문자열인지의 결과를 YES 또는 NO로 출력합니다.


예시 입력 1 

gooG
예시 출력 1

YES

출처 : https://cote.inflearn.com/contest/10/problem/01-07

## 내가 푼 코드(StringBuilder reverse 활용)

전에 배웠던 StringBuilder의 reverse 내장함수를 이용해 문자열을 뒤집고, 뒤집은 문자열과 기존의 문자열이 같은지 확인하는 방식으로 품

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Locale;

public class 회문_문자열 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String input = br.readLine().toLowerCase(Locale.ROOT);
        String reverse = new StringBuilder(input).reverse().toString();

        if(input.equals(reverse)){
            System.out.println("YES");
        } else {
            System.out.println("NO");
        }
        br.close();
    }
}
```

## 직접 해주는 방법

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Locale;

public class 회문_문자열 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        char[] input = br.readLine().toLowerCase(Locale.ROOT).toCharArray();
        boolean flag = false;
        int last = input.length-1;
        for (int i = 0; i < input.length / 2; i++) {
            if(input[i] != input[last-i]){
                flag = true;
            }
        }
        if(flag)
            System.out.println("NO");
        else
            System.out.println("YES");
        br.close();
    }
}
```

## toUpperCase() + equals() 대신 equalsIgnoreCase() 사용

대소문자를 무시하고 비교하는 equalsIgnoreCase() 사용 방법

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Locale;

public class 회문_문자열 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String input = br.readLine();
        String reverse = new StringBuilder(input).reverse().toString();

        if(input.equalsIgnoreCase(reverse)){
            System.out.println("YES");
        } else {
            System.out.println("NO");
        }
        br.close();
    }
}
```